%forecast MES
% INPUTS:

% h-forecast lead 
%i ndex asset !!! only in -sample!!!
% S = number of paths to be simulated
% C = market drop representing the systemic event
%{
clc
clear all
load data_set;
asset=returns(:,2);
index=returns(:,3);
h=123;

S=20000;
C=-0.4
    addpath('/Users/ivona_d/Documents/D /D1/Papers/CES/CompES/MES_sylvain');
  index=return_Mk_T;                                       % Returns of the market (system)
    asset=returns_T(:,28);                                      % Returns of the asset

asset(find(asset==max(asset)))=mean(asset);
asset(find(asset==min(asset)))=mean(asset);


h=10000;
S=1;
C=-0.4;
    addpath('/Users/ivona_d/Documents/D /D1/Papers/CES/CompES/MES_sylvain');
  index=return_Mk_T;                                       % Returns of the market (system)
    asset=returns_T(:,2);                                      % Returns of the asset



[res] = forecast_MES(index,asset, h,S,C)
 rmpath('/Users/ivona_d/Documents/D /D1/Papers/CES/CompES/MES_sylvain');
%}

%function [res] = forecast2(index,asset, h,S,C)
%{
S=200000;
C=-0.3;
index=return_Mk_T;                                                         % Returns of the market (system)
asset=returns_T(:,3);                                                     % Returns of the asset
addpath('/Volumes/Mac HD/D /D1/Papers/CES/CompES/codes Matlab/OOS/MES_sylvain');
%}

%warning off

function [res] = forecast2(index,asset, h,S)
%% Data treatment

data = [index asset];
data = data(~isnan(data(:,2).*data(:,1)),:);                               % select only elements which are not NaN
data_center = data - ones(size(data,1),1)*mean(data);                      % demeaned returns

index_c=data_center(:,1);                                                  % centered data
asset_c=data_center(:,2);
%% ESTIMATION  GJR-GARCH and DCC

[parameters, loglikelihood, Ht, Rt, Qt, stdresid, likelihoods, stderrors, A,B, jointscores, H]=dcc_mvgarch(data_center,1,1,1,1);

ht_m=H(:,1);                                                               % market conditional volatility  !!! VARIANCE

ht_i=H(:,2);                                                               % asset conditional volatility

rho=squeeze(Rt(1,2,:));                                                    % conditional correlation

%FORECASTS

%0. Compute the Standardized Residuals 

ep_m=stdresid(:,1);                                                        % std resid for the market 
ep_i=(stdresid(:,2)-rho.*ep_m)./sqrt(1-rho.*rho);% std resid for the firm 

epss=[ep_m ep_i];                                                          % matrix of std resid     
eps=epss;

%{
%verif

eps_s=epss(1001:1200,:);
h=200

%2. Conditional Volatilities and returns
        %Initalize
        ht_ms=NaN*ones(h,1);
        rt_ms=ht_ms;
        
        %2.1 Market
        param_m=[ (1-(parameters(1)+0.5*parameters(2)+parameters(3)))*var(index_c); parameters(1); parameters(2); parameters(3)]; 
        rt_m=index_c(1000);                                        % last in-sample return
        ht_mm=ht_m(1000);                                     % last in-sample cond volat (variance)
        Indm=(rt_m<0);                                              % indicator =1 if true

        for i=1:h

            ht_ms(i)= [1 rt_m^2  rt_m^2*Indm ht_mm]* param_m; % conditional volatility 

            rt_ms(i)=sqrt(ht_ms(i))*eps_s(i,1);                  % forecasted return at  time t+i for the market

            rt_m=rt_ms(i);                                         % new return

            ht_mm=ht_ms(i);

            Indm=(rt_m<0);                                         % indicator =1 if true
        end
              
        std_ms=rt_ms./sqrt(ht_ms);                       % forecasted stdandardized resid (h,1) for market

        %2.2 Firm
        %Initalize
        ht_is=NaN*ones(h,1);
        rt_is=ht_ms;
        rho_s=ht_ms;
        std_is=ht_ms;
        
        param_i=[ (1-(parameters(4)+0.5*parameters(5)+parameters(6)))*var(asset_c); parameters(4); parameters(5); parameters(6)]; 
        param_dcc=[1-(parameters(7)+parameters(8)); parameters(7); parameters(8)]; % param dcc
        rt_i=asset_c(1000);
        ht_ii=ht_i(1000);
        Q=Qt(:,:,1000);                                             % VCV Q matrix at time t for forecasts at t+1
        Q_bar=cov(stdresid);                                  % ~= Unconditional variance (Sbar from B&E 2012 article)
        QQ_s=stdresid(1000,:)'*stdresid(1000,:);       % covariance at time t of the std resid
        Ind=(rt_i<0);                                                % indicator =1 if true

        for i=1:h
            
              ht_is(i)= [1 rt_i^2  rt_i^2*Ind ht_ii]* param_i; % conditional volatility 

               % DCC - forecast rho
              Q_s= param_dcc(1)*Q_bar + param_dcc(2)*QQ_s+ param_dcc(3)*Q;
Q_sbb(:,:,i)=Q_s;
              Rt_s=diag((diag(Q_s)).^(-1/2))*Q_s*diag((diag(Q_s)).^(-1/2));      
Rt_sbb(:,:,i)=Rt_s;
              rho_s(i)=Rt_s(1,2);                               % correlation coefficient (forecast at t+i)

               % return
               rt_is(i)=sqrt(ht_is(i))*( rho_s(i) * eps_s(i,1) +sqrt(1-rho_s(i)^2)*eps_s(i,2) ); % forecated return at time t+i

               std_is(i)= rho_s(i) * eps_s(i,1) +sqrt(1-rho_s(i)^2)*eps_s(i,2); 

               Q=Q_s;                                                % previous value of Q_s

               QQ_s=[std_ms(i) std_is(i)]'*[std_ms(i) std_is(i)]; %  covariance at time t+1 of the std resid
%QQ_sbb(:,:,i)=QQ_s;

               ht_ii=ht_is(i);

               rt_i=rt_is(i);
               
               Ind=(rt_i<0);                                         % indicator =1 if true

        end


[rt_ms index_c(1001:1200)]
[rt_is asset_c(1001:1200)]
[rho_s rho(1001:1200)]
[ht_is ht_i(1001:1200)]
[std_ms std_is stdresid(1001:1200,:)]
[Qt(:,:,1001) Q_sbb(:,:,1)]
[Rt(:,:,1001) Rt_sbb(:,:,1)]
%[ QQ_sbb(:,:,1)]

%}

%{
q1=quantile(epss(:,2), alpha);                          % 2.5%  -
q2=quantile(epss(:,2), 1-alpha);                        %97.5% +

eps=[];
for i=1:length(epss(:,2))
    if epss(i,2)>q1 && epss(i,2)<q2
eps=[eps; epss(i,:)];
    end
end
%}

%%%%LOOP: S paths
%Initialize
Rtcum_s=NaN*ones(S,2);

RTM=NaN*ones(h,S);
RTI=RTM;
HTM=RTM;
HTI=RTM;
EPSSm=RTM;
EPSSi=RTM;
RHO=RTM;
for s=1:S

    %1. Draw  S paths of length h of Standardized Residuals

        T=ceil(rand(1,h)*(size(eps,1)-1))+1;                               % indicators in the position to draw

        eps_s=eps(T,:);                                                    % resampled std residuals

EPSSm(:,s)=eps_s(:,1);
EPSSi(:,s)=eps_s(:,2);


        %2. Conditional Volatilities and returns
        %Initalize
        ht_ms=NaN*ones(h,1);
        rt_ms=ht_ms;
        
        %2.1 Market
        param_m=[ (1-(parameters(1)+0.5*parameters(2)+parameters(3)))*var(index_c); parameters(1); parameters(2); parameters(3)]; 
        rt_m=index_c(end);                                                 % last in-sample return
        ht_mm=ht_m(end);                                                   % last in-sample cond volat (variance)
        Indm=(rt_m<0);                                                     % indicator =1 if true

        for i=1:h

            ht_ms(i)= [1 rt_m^2  rt_m^2*Indm ht_mm]* param_m;              % conditional volatility 

            rt_ms(i)=sqrt(ht_ms(i))*eps_s(i,1);                            % forecasted return at  time t+i for the market

            rt_m=rt_ms(i);                                                 % new return

            ht_mm=ht_ms(i);

            Indm=(rt_m<0);                                                 % indicator =1 if true
        end
HTM(:,s)=ht_ms;
RTM(:,s)=rt_ms;        
        
        
        std_ms=rt_ms./sqrt(ht_ms);                                         % forecasted stdandardized resid (h,1) for market

        %2.2 Firm
        %Initalize
        ht_is=NaN*ones(h,1);
        rt_is=ht_is;
        rho_s=ht_is;
        std_is=ht_is;
        
        param_i=[ (1-(parameters(4)+0.5*parameters(5)+parameters(6)))*var(asset_c); parameters(4); parameters(5); parameters(6)]; 
        param_dcc=[1-(parameters(7)+parameters(8)); parameters(7); parameters(8)]; % param dcc
        rt_i=asset_c(end);
        ht_ii=ht_i(end);
        Q=Qt(:,:,end);                                                      % VCV Q matrix at time t for forecasts at t+1
        Q_bar=cov(stdresid);                                                % ~= Unconditional variance (Sbar from B&E 2012 article)
        QQ_s=stdresid(end,:)'*stdresid(end,:);                              % covariance at time t of the std resid
        Ind=(rt_i<0);                                                       % indicator =1 if true

        for i=1:h
            
              ht_is(i)= [1 rt_i^2  rt_i^2*Ind ht_ii]* param_i;             % conditional volatility 

               % DCC - forecast rho
              Q_s= param_dcc(1)*Q_bar + param_dcc(2)*QQ_s+ param_dcc(3)*Q;

              Rt_s=diag((diag(Q_s)).^(-1/2))*Q_s*diag((diag(Q_s)).^(-1/2));      

              rho_s(i)=Rt_s(1,2);                                          % correlation coefficient (forecast at t+i)

               % return
               rt_is(i)=sqrt(ht_is(i))*( rho_s(i) * eps_s(i,1) +sqrt(1-rho_s(i)^2)*eps_s(i,2) ); % forecated return at time t+i

               %std_is(i)=rt_is(i)./sqrt(ht_is(i));                        % forecasted stdandardized resid (h,1) for firm
               std_is(i)=rho_s(i) * eps_s(i,1) +sqrt(1-rho_s(i)^2)*eps_s(i,2);
                
               Q=Q_s;                                                      % previous value of Q_s

               QQ_s=[std_ms(i) std_is(i)]'*[std_ms(i) std_is(i)];          %  covariance at time t+1 of the std resid

               ht_ii=ht_is(i);

               rt_i=rt_is(i);
               
               Ind=(rt_i<0);                                               % indicator =1 if true

        end

HTI(:,s)=ht_is;
RTI(:,s)=rt_is;
RHO(:,s)=rho_s;
        %3. Cummulated returns 
        Rtcum_s(s,1)=exp(sum(rt_ms) )-1;                                   % Cummulated returns for market
        Rtcum_s(s,2)=exp(sum(rt_is) )-1;                                   % Cummulated returns for firm


end

%4. Forecast MES
%C
C=quantile(Rtcum_s(:,1),0.05);                                             %cutoff

%indicator
Indcum=(Rtcum_s(:,1)<C);                                                   % Indicator

%MES
MES_oos=sum(Rtcum_s(:,2).*Indcum)/sum(Indcum);                             % Cummulated MES

%{
alpha=0.025;
Rt_se=Rtcum_s(Rtcum_s(:,1)<C,:);
q1=quantile(Rt_se(:,2), alpha);                          % 2.5%  -
q2=quantile(Rt_se(:,2), 1-alpha);                        %97.5% +

Rt_sei=[];
for i=1:length(Rt_se(:,2))
    if Rt_se(i,2)>q1 && Rt_se(i,2)<q2
Rt_sei=[Rt_sei; Rt_se(i,2)];
    end
end

MES_q=sum(Rt_sei)/length(Rt_sei); % Cummulated MES

%}
%MES

%% Affectations 
res.Rtcum_s=Rtcum_s;
res.MES_oos=-MES_oos;
res.C=C;
%veriff
%{
rett(:,1)=[index; rt_ms];
rett(:,2)=[asset; rt_is];


rett=[rt_ms rt_is];
rett_center = rett - ones(size(rett,1),1)*mean(rett); %demeaned returns

rett_center=[rt_ms rt_is];
[parameters_ff, loglikelihood_ff, Ht_ff, Rt_ff, Qt_ff, stdresid_ff, likelihoods_ff, stderrors_ff, A_ff,B_ff, jointscores_ff, H_ff]=dcc_mvgarch(rett_center,1,1,1,1);

ex=Rtcum_s(Rtcum_s(:,1)<C,:)
ex1=sortrows(ex,2);

find(ex(:,2)==max(ex(:,2)))
 
find(Rtcum_s(:,2)==max(Rtcum_s(:,2)))

%}

